/*****************************************************************************\
*   opt_lptled1.3                                                29.11.2003   *
*                                                                             *
*   lptled - Ansteuern von LED`s an einem Parallelport                        *
*   Copyright (C) 2000 bei Georg Kainzbauer <georgkainzbauer@gmx.net>         *
*                                                                             *
*   This program is free software; you can redistribute it and/or modify      *
*   it under the terms of the GNU General Public License as published by      *
*   the Free Software Foundation; either version 2 of the License, or         *
*   (at your option) any later version.                                       *
*                                                                             *
*   This program is distributed in the hope that it will be useful,           *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of            *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
*   GNU General Public License for more details.                              *
*                                                                             *
*   You should have received a copy of the GNU General Public License         *
*   along with this program; if not, write to the Free Software Foundation,   *
*   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.            *
\*****************************************************************************/

#define VERINFO "opt_lptled1.3"
#include <stdio.h>
#include <stdlib.h>

FILE *Infile;
char FileInhalt[4];
int LEDStatus;
int LEDTime1 = 0, LEDTime2 = 0, LEDTime3 = 0, LEDTime4 = 0;
int LEDTime5 = 0, LEDTime6 = 0, LEDTime7 = 0, LEDTime8 = 0;
int Counter1 = 0, Counter2 = 0, Counter3 = 0, Counter4 = 0;
int Counter5 = 0, Counter6 = 0, Counter7 = 0, Counter8 = 0;

void help();
void LEDControl();

int main(int argc, char** argv)
  {
    /* Parameterprfung */
    if(argc != 9)
      {
        help();
      }

    /* LED-Abfragezeiten einlesen */
    LEDTime1 = atoi(argv[1]);
    LEDTime2 = atoi(argv[2]);
    LEDTime3 = atoi(argv[3]);
    LEDTime4 = atoi(argv[4]);
    LEDTime5 = atoi(argv[5]);
    LEDTime6 = atoi(argv[6]);
    LEDTime7 = atoi(argv[7]);
    LEDTime8 = atoi(argv[8]);

    /* LED-Ansteuerung aufrufen */
    LEDControl();

    return 0;
  }

void help()
  {
    #ifdef VERINFO
      puts(VERINFO);
    #endif
    printf("\nLPTLED ermglicht das Ansteuern von 8 LED's am parallelen Port.\n");
    printf("Aufruf: ");
    printf("  lptled <led1time> <led2time> <led3time> ... <led8time>\n");
    exit(0);
  }

/* LED-Ansteuerung */
void LEDControl()
  {
    while(1)
      {
        usleep(1000000); /* 1s Delay */
        Counter1++;
        Counter2++;
        Counter3++;
        Counter4++;
        Counter5++;
        Counter6++;
        Counter7++;
        Counter8++;

        /* LED-Ansteuerung: LED1 */
        if (LEDTime1 == Counter1)
          {
            system("/usr/local/lptled/script1");
            Infile = fopen("/var/run/lptled/led1","rb+");
            fscanf(Infile, "%s", FileInhalt);
            fclose(Infile);
            if(strcmp("on",FileInhalt)==0) LEDStatus=1;
            if(strcmp("off",FileInhalt)==0) LEDStatus=2;
            switch (LEDStatus)
              {
                case 1:
                  system("/usr/local/lptled/k74 0 set");
                  break;
                case 2:
                  system("/usr/local/lptled/k74 0 clear");
                  break;
                default:
                  printf("FEHLER - Statusfile konnte nicht ausgewertet werden");
                  break;
              }
            Counter1 = 0;
          }

        /* LED-Ansteuerung: LED2 */
        if (LEDTime2 == Counter2)
          {
            system("/usr/local/lptled/script2");
            Infile = fopen("/var/run/lptled/led2","rb+");
            fscanf(Infile, "%s", FileInhalt);
            fclose(Infile);
            if(strcmp("on",FileInhalt)==0) LEDStatus=1;
            if(strcmp("off",FileInhalt)==0) LEDStatus=2;
            switch (LEDStatus)
              {
                case 1:
                  system("/usr/local/lptled/k74 1 set");
                  break;
                case 2:
                  system("/usr/local/lptled/k74 1 clear");
                  break;
                default:
                  printf("FEHLER - Statusfile konnte nicht ausgewertet werden");
                  break;
              }
            Counter2 = 0;
          }

        /* LED-Ansteuerung: LED3 */
        if (LEDTime3 == Counter3)
          {
            system("/usr/local/lptled/script3");
            Infile = fopen("/var/run/lptled/led3","rb+");
            fscanf(Infile, "%s", FileInhalt);
            fclose(Infile);
            if(strcmp("on",FileInhalt)==0) LEDStatus=1;
            if(strcmp("off",FileInhalt)==0) LEDStatus=2;
            switch (LEDStatus)
              {
                case 1:
                  system("/usr/local/lptled/k74 2 set");
                  break;
                case 2:
                  system("/usr/local/lptled/k74 2 clear");
                  break;
                default:
                  printf("FEHLER - Statusfile konnte nicht ausgewertet werden");
                  break;
              }
            Counter3 = 0;
          }

        /* LED-Ansteuerung: LED4 */
        if (LEDTime4 == Counter4)
          {
            system("/usr/local/lptled/script4");
            Infile = fopen("/var/run/lptled/led4","rb+");
            fscanf(Infile, "%s", FileInhalt);
            fclose(Infile);
            if(strcmp("on",FileInhalt)==0) LEDStatus=1;
            if(strcmp("off",FileInhalt)==0) LEDStatus=2;
            switch (LEDStatus)
              {
              case 1:
                system("/usr/local/lptled/k74 3 set");
                break;
              case 2:
                system("/usr/local/lptled/k74 3 clear");
                break;
              default:
                printf("FEHLER - Statusfile konnte nicht ausgewertet werden");
                break;
              }
            Counter4 = 0;
          }

        /* LED-Ansteuerung: LED5 */
        if (LEDTime5 == Counter5)
          {
            system("/usr/local/lptled/script5");
            Infile = fopen("/var/run/lptled/led5","rb+");
            fscanf(Infile, "%s", FileInhalt);
            fclose(Infile);
            if(strcmp("on",FileInhalt)==0) LEDStatus=1;
            if(strcmp("off",FileInhalt)==0) LEDStatus=2;
            switch (LEDStatus)
              {
              case 1:
                system("/usr/local/lptled/k74 4 set");
                break;
              case 2:
                system("/usr/local/lptled/k74 4 clear");
                break;
              default:
                printf("FEHLER - Statusfile konnte nicht ausgewertet werden");
                break;
              }
            Counter5 = 0;
          }

        /* LED-Ansteuerung: LED6 */
        if (LEDTime6 == Counter6)
          {
            system("/usr/local/lptled/script6");
            Infile = fopen("/var/run/lptled/led6","rb+");
            fscanf(Infile, "%s", FileInhalt);
            fclose(Infile);
            if(strcmp("on",FileInhalt)==0) LEDStatus=1;
            if(strcmp("off",FileInhalt)==0) LEDStatus=2;
            switch (LEDStatus)
              {
              case 1:
                system("/usr/local/lptled/k74 5 set");
                break;
              case 2:
                system("/usr/local/lptled/k74 5 clear");
                break;
              default:
                printf("FEHLER - Statusfile konnte nicht ausgewertet werden");
                break;
              }
            Counter6 = 0;
          }

        /* LED-Ansteuerung: LED7 */
        if (LEDTime7 == Counter7)
          {
            system("/usr/local/lptled/script7");
            Infile = fopen("/var/run/lptled/led7","rb+");
            fscanf(Infile, "%s", FileInhalt);
            fclose(Infile);
            if(strcmp("on",FileInhalt)==0) LEDStatus=1;
            if(strcmp("off",FileInhalt)==0) LEDStatus=2;
            switch (LEDStatus)
              {
              case 1:
                system("/usr/local/lptled/k74 6 set");
                break;
              case 2:
                system("/usr/local/lptled/k74 6 clear");
                break;
              default:
                printf("FEHLER - Statusfile konnte nicht ausgewertet werden");
                break;
              }
            Counter7 = 0;
          }

        /* LED-Ansteuerung: LED8 */
        if (LEDTime8 == Counter8)
          {
            system("/usr/local/lptled/script8");
            Infile = fopen("/var/run/lptled/led8","rb+");
            fscanf(Infile, "%s", FileInhalt);
            fclose(Infile);
            if(strcmp("on",FileInhalt)==0) LEDStatus=1;
            if(strcmp("off",FileInhalt)==0) LEDStatus=2;
            switch (LEDStatus)
              {
              case 1:
                system("/usr/local/lptled/k74 7 set");
                break;
              case 2:
                system("/usr/local/lptled/k74 7 clear");
                break;
              default:
                printf("FEHLER - Statusfile konnte nicht ausgewertet werden");
                break;
              }
            Counter8 = 0;
          }
      }
  }